#include <metal_stdlib>
using namespace metal;
#import "Common.h"
#import "ShadersDefs.h"

struct VertexIn {
    float3 position [[attribute(0)]];
    float3 normal [[attribute(1)]];
};

vertex VertexOut vertex_main(
                             VertexIn in [[stage_in]],
                             constant Uniforms &uniforms [[buffer(11)]])
{
    float4 position =
    uniforms.projectionMatrix * uniforms.viewMatrix
    * uniforms.modelMatrix * float4(in.position, 1);
    VertexOut out {
        .position = position,
        .normal = in.normal
    };
    return out;
}

